; kernel.asm

[BITS 16]
[ORG 0x1000]

start:
    mov ax, 0x0003
    int 0x10
    mov si, welcome_msg
    call print_string

main_loop:
    mov ah, 0x00
    int 0x16
    cmp ah, 0x3F      ; F5 scan code
    je clear_screen
    ; Check if character is ASCII (0x20 to 0x7E)
    cmp al, 0x20
    jb check_control
    cmp al, 0x7E
    ja main_loop
    mov ah, 0x0E
    int 0x10
    jmp main_loop

check_control:
    cmp al, 0x0D      ; Enter
    je handle_enter
    cmp al, 0x08      ; Backspace  
    je handle_backspace
    jmp main_loop

clear_screen:
    mov ax, 0x0003    ; Text mode 80x25 16 colors
    int 0x10
    jmp main_loop

handle_enter:
    mov ah, 0x0E
    mov al, 0x0D
    int 0x10
    mov al, 0x0A
    int 0x10
    jmp main_loop

handle_backspace:
    mov ah, 0x0E
    mov al, 0x08
    int 0x10
    mov al, ' '
    int 0x10
    mov al, 0x08
    int 0x10
    jmp main_loop

print_string:
    mov ah, 0x0E

.loop:
    lodsb
    test al, al
    jz .done
    int 0x10
    jmp .loop

.done:
    ret

welcome_msg db 'ExploreSoft (C) Typing Simulator (TM) Version 1.0.0', 0x0D, 0x0A
            db 'Press F5 to clear the screen.', 0x0D, 0x0A, 0x0D, 0x0A
            db 'Start typing...', 0x0D, 0x0A, 0x0D, 0x0A, 0

times 1024-($-$$) db 0